#!/usr/bin/env python3
import rospy
import numpy as np
from assign3.tools import *
from copy import copy
import random


from geometry_msgs.msg import ***


dt = 0.1 # Approximate time difference between measurements
N = 1000  # Number of particles
resolution = 0.01 # Resolution for height map


if __name__ == "__main__":
    # Initialize node
    rospy.init_node('Particle_filter', anonymous=True)

    # ROS refresh rate
    rate = rospy.Rate(1/dt) # hz

    # Create height map for the workspace. Dimension -> (8/resolution,15/resolution)
    height_map = create_height_map(resolution)

    # This publisher will publish your results
    pub = rospy.Publisher('/particle_filter',***,queue_size=1)

    # Define particles
    particles = ***

    # Initialize particles
    particles = ***

    # Initialize weights
    weights   = ***

    # ** Do not change **
    # prev_x,prev_y are ground truth you can not use them in your code, it's for internal calculation
    previous_position =  rospy.wait_for_message("/drone/gt_pose",Pose,timeout=None)
    prev_x = previous_position.position.x
    prev_y = previous_position.position.y
    # -----------------------------------------------------------------------
    while not rospy.is_shutdown():
        # Measurements.
        dx,dy = get_measurement(prev_x,prev_y)
        prev_x = prev_x + dx
        prev_y = prev_y + dy
        range_finder,actual_height = find_vertical_distance(height_map,resolution)
        #----------------------------------------
        # Measurements:
        # dx, dy = displacement from previous position x and y
        # range_finder = vertical distance 
        # height  = Height of drone (from ground)

        # Note: If you create functions, passing arrays or msgs to them means passing pointers.
        # IF you modify them inside the function they will change and outside. You can use copy(array/msg)

        # Randomly sample from particle distrubition (tip: You can create particles close to the ones you already have)
        particles = ***

        # Update particles
        ***


        # Compute weights. Figure out a metric that will give penalty to particle_i(x_i,y_i)
        weights = ***

        # Resampling step
        ***

        pub.publish(particles)
        rate.sleep()
